// run data through first DataShopSTPreprocessor before running this program. 
// for ron data, also run RonDimensionalityReducer before running this program
// afterwards, run DataShopToGamingDetectorpt1 
// this version does not convert BLANK prods to the next prod
// but it is *much* faster
// (i.e. use with large DataShop data sets where KCs have already been assigned well)

// needs -Xms1500M -Xmx1500M

import java.io.*;

public class DataShopBRPreprocessorStraightThroughA {

    public static String algebra_hampton_in = "C:\\RawData\\HamptonAlgI0506\\export-modD.txt";
    public static String algebra_hampton_out = "C:\\RawData\\HamptonAlgI0506\\export-modE.txt";
    public static String geometry_hampton_in = "C:\\RawData\\HamptonGeoFall2005\\export-modA.txt";
    public static String geometry_hampton_out = "C:\\RawData\\HamptonGeoFall2005\\export-modB.txt";
    public static String ronex_in = "C:\\RawData\\RonExampleTutors\\exampletutor-modB.txt";
    public static String ronex_out = "C:\\RawData\\RonExampleTutors\\exampletutor-modC.txt";   
    public static String circles_in = "C:\\RawData\\RonExampleTutors\\Circles\\All-Circles-modA.txt";  
    public static String circles_out = "C:\\RawData\\RonExampleTutors\\Circles\\All-Circles-modB.txt";

   public static String algebra_cwctc2005_in = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\cwctc_Alg_2005-modA.txt";
    public static String algebra_cwctc2005_out = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\cwctc_Alg_2005-modB.txt";
    public static String algebra_wilk2005_in = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\wilkinsburg_Alg_2005-modA.txt";
    public static String algebra_wilk2005_out = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\wilkinsburg_Alg_2005-modB.txt";
    public static String algebra_wilk2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\wilkinsburg_hs_842_export-modA.txt";
    public static String algebra_wilk2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\wilkinsburg_hs_842_export-modB.txt";
    public static String algebra_madison2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\madison_middle_school_840_export-modA.txt";
    public static String algebra_madison2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\madison_middle_school_840_export-modB.txt";
    public static String algebra_hampton2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\hampton_837_export-modA.txt";
    public static String algebra_hampton2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\hampton_837_export-modB.txt";
    public static String algebra_gv2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\golden_valley_843_export-modA.txt";
    public static String algebra_gv2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\golden_valley_843_export-modB.txt";
    public static String algebra_cwctc2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\cwctc_841_export-modA.txt";
    public static String algebra_cwctc2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\cwctc_841_export-modB.txt";
    public static String algebra_edison2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\edison_middle_school_838_export-modA.txt";
    public static String algebra_edison2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\edison_middle_school_838_export-modB.txt";
    public static String RAND2007_in = "H:\\RawData-annex\\RAND_Study_Baltimore_2007_2008\\All_Data_853_export-modA.txt";
    public static String RAND2007_out = "H:\\RawData-annex\\RAND_Study_Baltimore_2007_2008\\All_Data_853_export-modB.txt";
    public static String geo_wilk2005_in = "H:\\RawData-annex\\Geometry_Wilkinsburg_2005_2006\\All_Data_552_export-modA.txt";
    public static String geo_wilk2005_out = "H:\\RawData-annex\\Geometry_Wilkinsburg_2005_2006\\All_Data_552_export-modB.txt";    
    public static String geo_cwctc2005_in = "H:\\RawData-annex\\Geometry_CWCTC_2005_2006\\All_Data_548_export-modA.txt";
    public static String geo_cwctc2005_out = "H:\\RawData-annex\\Geometry_CWCTC_2005_2006\\All_Data_548_export-modB.txt";
    public static String geo_wilk2006_in = "H:\\RawData-annex\\Geometry_2006_2007\\wilkinsburgh_896_export-modA.txt";
    public static String geo_wilk2006_out = "H:\\RawData-annex\\Geometry_2006_2007\\wilkinsburgh_896-modB.txt";


    public String in_file_ = "";
    public String out_file_ = "";
    public FileReader in_;
    public FileWriter out_;
    int curchar = -77; 
    int lineno = 0; int trueline = 1;
    public String lesson_type = "GEOMETRY"; // or "GEOMETRY" or "RONEX" or "ALGEBRA" "ALGEBRA-NS" "ALGEBRA-2006" or "RAND" or "GEOMETRY_2005"

    public FileReader create_tokenizer(String infile){		      
	
	try{
	    return new FileReader(infile);
	}	
	catch (FileNotFoundException fnfe){
	    fnfe.printStackTrace();
	}
	return null;
    }	
    public FileWriter out_tokenizer(String outfile){
	try{
	    return new FileWriter(outfile);
	}
	catch (Exception fnfe){
	    fnfe.printStackTrace();
	}
	return null;
    }

    public void skipToEOL() throws IOException{
	while ((curchar != 10)&&(curchar != -1))
	    curchar = in_.read();
    }

    public String read_in_field() throws IOException{	
	char[] forconvert = new char[1];
	
	String toret = ""; 
	curchar = in_.read(); 
	while ((curchar != 9)&&(curchar != -1)&&(curchar != 10)){
	    if ((curchar != 9)&&(curchar != -1)&&(curchar != 10)){
		forconvert[0] = (char)curchar;
		toret = toret + new String(forconvert);
		curchar = in_.read(); 
	    }
	    if (curchar == 10)
		throw new RuntimeException("Unexpected EOLN encountered");
	    //System.out.println(curchar);
	}
	//System.out.println();
	return toret;
    }

    public void convert(){
	in_ = create_tokenizer(in_file_);
	out_ = out_tokenizer(out_file_);

	String[] curname = new String[1]; 
	String[] session = new String[1];  
	String[] day = new String[1];
	String[] time = new String[1];
	String[] timezone_cx = new String[1]; 
	String[] actiontype = new String[1];
        String[] actionsubtype_cx = new String[1];    
	String[] tutoractiontype = new String[1];    
	String[] tutoractionsubtype_cx = new String[1];
	String[] curlesson =   new String[1];
	String[] section_cx =    new String[1];
	String[] problem =   new String[1];
	String[] step =   new String[1];
	String[] attemptatstep =   new String[1];
	String[] outcome =   new String[1];
	String[] selection =   new String[1];
	String[] action =   new String[1];
	String[] input =   new String[1];
	String[] feedbacktext =   new String[1];
	String[] feedbacktype =   new String[1];
	String[] helplevel =   new String[1];
	String[] totalnumhints =   new String[1];
	String[] conditionname =   new String[1];
	String[] conditiontype =   new String[1];
	String[] prod1 =   new String[1];
	String[] prodcx1 =   new String[1];
	String[] prod2 =   new String[1];
	String[] prodcx2 =  new String[1];
	String[] prod3 =   new String[1];
	String[] prodcx3 =  new String[1];
	String[] prod4 =   new String[1];
	String[] prodcx4 =  new String[1];
	String[] school =   new String[1];
	String[] clazz =   new String[1];
	String[] geojunk = new String[1];
	String[] leveldefault = new String[1]; // I have no idea what this is but it is in Ron's data

	lineno = 0; trueline = 1;

	try{

	    if (!lesson_type.equals("ALGEBRA_NS"))
		skipToEOL();
	    
	    if (!lesson_type.equals("RAND")&&!lesson_type.equals("ALGEBRA_NS")&&!lesson_type.equals("ALGEBRA_2006")){
		curchar = in_.read();
		skipToEOL();
	    }	    	  

	    out_.write("HEADERS\nHEADERS");

	    while (curchar != -1){ // EOF
		trueline++;
		
		if ((lesson_type.equals("CIRCLES"))||(lesson_type.equals("RAND"))||(lesson_type.equals("GEOMETRY_2005"))||(lesson_type.equals("ALGEBRA_NS"))||(lesson_type.equals("ALGEBRA_2006"))) 
		    read_in_field(); // sample name
		//read in DataShop line		

		if (curchar != -1)
		    curname[lineno] = read_in_field();
		
		if (curchar != -1){

		    session[lineno] = read_in_field();
	       
		    //day = read_in_field();
		    time[lineno] = read_in_field();
		    
		    if (!lesson_type.equals("ALGEBRA_NS"))
			timezone_cx[lineno] = read_in_field();
		    else
			timezone_cx[lineno] = "BLANK";
		    
		    actiontype[lineno] = read_in_field();
		    actionsubtype_cx[lineno] = read_in_field();
		    tutoractiontype[lineno]= read_in_field();
		    tutoractionsubtype_cx[lineno]= read_in_field();
		    
		    if ((lesson_type.equals("RONEX"))||(lesson_type.equals("CIRCLES"))) 
			leveldefault[lineno]=read_in_field(); 
		    else
			leveldefault[lineno]="IGNORE";
		    
		    curlesson[lineno]= read_in_field();
		    section_cx[lineno]= read_in_field();
		    
		    problem[lineno]= read_in_field();
		    
		    step[lineno]= read_in_field();
		    attemptatstep[lineno]= read_in_field();
		    outcome[lineno]= read_in_field();
		    selection[lineno]= read_in_field();
		    action[lineno]= read_in_field();
		    input[lineno]= read_in_field();
		    feedbacktext[lineno]= read_in_field();
		    feedbacktype[lineno]= read_in_field();
		    helplevel[lineno]= read_in_field();
		    totalnumhints[lineno]= read_in_field();
		    if (lesson_type.equals("ALGEBRA")||lesson_type.equals("RONEX")||lesson_type.equals("RAND")||(lesson_type.equals("CIRCLES"))){
			conditionname[lineno]= read_in_field();
		    conditiontype[lineno]= read_in_field();
		    }
		    else{
			conditionname[lineno]="IGNORE";
			conditiontype[lineno]="IGNORE";
		    }

		    if (lesson_type.equals("ALGEBRA_NS")){ 
			read_in_field();read_in_field();read_in_field();
		    }
		    if (lesson_type.equals("CIRCLES")){ 
			read_in_field();read_in_field();read_in_field();
			read_in_field();read_in_field();read_in_field();
		    }
		    if (!lesson_type.equals("RAND")){
			if (lesson_type.equals("ALGEBRA_NS")){
			    prod2[lineno]= read_in_field();
			    prodcx2[lineno]= read_in_field();
			    for (int i=0;i<8;i++)
				read_in_field(); // apparently unused prod fields
			    prod1[lineno]= read_in_field();
			    prodcx1[lineno]= read_in_field();
			    prod3[lineno]= "BLANK";
			    prodcx3[lineno]= "BLANK";
			    prod4[lineno]= "BLANK";
			    prodcx4[lineno]= "BLANK";
			}
			else{
			    prod1[lineno]= read_in_field();
			    prodcx1[lineno]= read_in_field();
			    prod2[lineno]= read_in_field();
			    prodcx2[lineno]= read_in_field();
			    prod3[lineno]= read_in_field();
			    prodcx3[lineno]= read_in_field();
			    prod4[lineno]= read_in_field();
			    prodcx4[lineno]= read_in_field();
			    if (lesson_type.equals("GEOMETRY_2005")){
				for (int i=0;i<40;i++)
				    read_in_field(); // apparently unused prod fields
			    }
			    if (lesson_type.equals("RONEX")){
				for (int i=0;i<8;i++)
				    read_in_field(); // apparently unused prod fields
			    }
			    if (lesson_type.equals("CIRCLES")){
				for (int i=0;i<4;i++)
				    read_in_field(); // apparently unused prod fields
			    }
			}
		    }
		    else{			
			prod1[lineno]= read_in_field();
			prodcx1[lineno]= read_in_field();			

			prod2[lineno]= read_in_field();
			prodcx2[lineno]= read_in_field();
			prod3[lineno]= read_in_field();
			prodcx3[lineno]= read_in_field();
			prod4[lineno]= read_in_field();
			prodcx4[lineno]= read_in_field();
			read_in_field();read_in_field();
		    }
		   

		    school[lineno]= read_in_field();
		    clazz[lineno]= read_in_field();
		   

		    if (lesson_type.equals("GEOMETRY")) // geometry_2005 has this too, but I don't think we want it. 
			geojunk[lineno]=read_in_field(); 
		    else
			geojunk[lineno]="IGNORE";
		    
		    if (lesson_type.equals("CIRCLES")){ 
			String errorkc = read_in_field(); 
			if (prod1[lineno].equals(""))
			    prod1[lineno] = errorkc;
		    }
		    
		    skipToEOL(); 
		    //tt = in_.nextToken();
		    // write out everything
		    
		    int i = lineno;
		    out_.write("\n");
		    out_.write(curname[i]);
		    out_.write("\t");
		    out_.write(session[i]);
		    out_.write("\t");
		    out_.write(time[i]);
		    out_.write("\t");
		    out_.write(timezone_cx[i]);
		    out_.write("\t");
		    out_.write(actiontype[i]);
		    out_.write("\t");
		    out_.write(actionsubtype_cx[i]);
		    out_.write("\t");
		    out_.write(tutoractiontype[i]);
		    out_.write("\t");
		    out_.write(tutoractionsubtype_cx[i]);
		    out_.write("\t");
		    if (!leveldefault[i].startsWith("IGNORE")){
			System.out.println(leveldefault[i]);
			out_.write(leveldefault[i]);
			out_.write("\t");
		    }
		    // System.out.println(curlesson[i]);
		    out_.write(curlesson[i]);
		    out_.write("\t");
		    out_.write(section_cx[i]);
		    out_.write("\t");
		    out_.write(problem[i]);
		    out_.write("\t");
		    out_.write(step[i]);
		    out_.write("\t");
		    out_.write(attemptatstep[i]);
		    out_.write("\t");
		    out_.write(outcome[i]);
		    out_.write("\t");
		    out_.write(selection[i]);
		    out_.write("\t");
		    out_.write(action[i]); 
		    out_.write("\t");
		    out_.write(input[i]);
		    out_.write("\t");
		    out_.write(feedbacktext[i]);
		    out_.write("\t");
		    out_.write(feedbacktype[i]);
		    out_.write("\t");
		    out_.write(helplevel[i]);
		    out_.write("\t");
		    out_.write(totalnumhints[i]);
		    out_.write("\t");
		    if (!conditionname[i].equals("IGNORE")){
			out_.write(conditionname[i]);
			out_.write("\t");
			out_.write(conditiontype[i]);
			out_.write("\t");
		    }
		    out_.write(prod1[i]);
		    out_.write("\t");
		    out_.write(prodcx1[i]);
		    out_.write("\t");
		    out_.write(prod2[i]);
		    out_.write("\t");
		    out_.write(prodcx2[i]);
		    out_.write("\t");
		    out_.write(prod3[i]);
		    out_.write("\t");
		    out_.write(prodcx3[i]);
		    out_.write("\t");
		    out_.write(prod4[i]);
		    out_.write("\t");
		    out_.write(prodcx4[i]);
		    out_.write("\t");
		    
		    out_.write(school[i]);
		    out_.write("\t");
		    if (!lesson_type.equals("RAND"))
			out_.write(clazz[i]);
		    else
			out_.write(clazz[i].substring(0,3));
			    
		    if (!geojunk[i].equals("IGNORE")){
			out_.write("\t");
			out_.write(geojunk[i]);
		    }
		    out_.write("\tEOL");
		    
		}
	    }
	    out_.flush();
	    out_.close();
	    
	}
	catch (Exception fnfe){
	    fnfe.printStackTrace();
	}
    }

    public static void main (String args[]){	
	DataShopBRPreprocessorStraightThroughA d_ = new DataShopBRPreprocessorStraightThroughA();

	if (args[0].equals("ahp1")){
	    d_.in_file_ = algebra_hampton_in;
	    d_.out_file_ = algebra_hampton_out;
	    d_.lesson_type = "ALGEBRA";
	    d_.convert();
        }	else
	if (args[0].equals("ghp1")){
	    d_.in_file_ = geometry_hampton_in;
	    d_.out_file_ = geometry_hampton_out;
	    d_.lesson_type = "GEOMETRY";
	    d_.convert();
        }else
	if (args[0].equals("circles")){
	    d_.in_file_ = circles_in;
	    d_.out_file_ = circles_out;
	    d_.lesson_type = "CIRCLES";
	    d_.convert();
        }else
	if (args[0].equals("ronex")){
	    d_.in_file_ = ronex_in;
	    d_.out_file_ = ronex_out;
	    d_.lesson_type = "RONEX";
	    d_.convert();
        }else
	if (args[0].equals("RAND")){
	    d_.in_file_ = RAND2007_in;
	    d_.out_file_ = RAND2007_out;
	    d_.lesson_type = "RAND";
	    d_.convert();
        }else
	if (args[0].equals("cwctc2005")){
	    d_.in_file_ = algebra_cwctc2005_in;
	    d_.out_file_ = algebra_cwctc2005_out;
	    d_.lesson_type = "ALGEBRA_NS";
	    d_.convert();
        }else
	if (args[0].equals("geo_wilk2006")){
	    d_.in_file_ = geo_wilk2006_in;
	    d_.out_file_ = geo_wilk2006_out;
	    d_.lesson_type = "GEOMETRY_2006";
	    d_.convert();
        }else
	if (args[0].equals("geo_wilk2005")){
	    d_.in_file_ = geo_wilk2005_in;
	    d_.out_file_ = geo_wilk2005_out;
	    d_.lesson_type = "GEOMETRY_2005";
	    d_.convert();
        }else
	if (args[0].equals("geo_cwctc2005")){
	    d_.in_file_ = geo_cwctc2005_in;
	    d_.out_file_ = geo_cwctc2005_out;
	    d_.lesson_type = "GEOMETRY_2005";
	    d_.convert();
        }else
	if (args[0].equals("wilk2005")){
	    d_.in_file_ = algebra_wilk2005_in;
	    d_.out_file_ = algebra_wilk2005_out;
	    d_.lesson_type = "ALGEBRA_NS";
	    d_.convert();
        }else
	if (args[0].equals("edison2006")){
	    d_.in_file_ = algebra_edison2006_in;
	    d_.out_file_ = algebra_edison2006_out;
	    d_.lesson_type = "ALGEBRA_2006";
	    d_.convert();
        }
	else System.out.println("No conversion specified");

    }
}