// This file takes raw datashop data and reprocesses it into a form
// that a StreamTokenizer-based distiller can easily handle
// Specifically: it converts underscores into Z
// And it inserts BLANK between <tab><tab>
// This is the first script to run!

import java.io.*;

public class DataShopSTPreprocessorB {

    public static String algebra_hampton_in = "C:\\RawData\\HamptonAlgI0506\\export.txt";
    public static String algebra_hampton_out = "C:\\RawData\\HamptonAlgI0506\\export-modD.txt";
    public static String algebra_cwctc2005_in = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\cwctc_Alg_2005.txt";
    public static String algebra_cwctc2005_out = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\cwctc_Alg_2005-modA.txt";
    public static String algebra_wilk2005_in = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\wilkinsburg_Alg_2005.txt";
    public static String algebra_wilk2005_out = "C:\\RawData\\Algebra_I_2005_2006_3_schools\\wilkinsburg_Alg_2005-modA.txt";
    public static String algebra_wilk2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\wilkinsburg_hs_842_export.txt";
    public static String algebra_wilk2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\wilkinsburg_hs_842_export-modA.txt";
    public static String algebra_madison2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\madison_middle_school_840_export.txt";
    public static String algebra_madison2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\madison_middle_school_840_export-modA.txt";
    public static String algebra_hampton2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\hampton_837_export.txt";
    public static String algebra_hampton2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\hampton_837_export-modA.txt";
    public static String algebra_gv2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\golden_valley_843_export.txt";
    public static String algebra_gv2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\golden_valley_843_export-modA.txt";
    public static String algebra_cwctc2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\cwctc_841_export.txt";
    public static String algebra_cwctc2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\cwctc_841_export-modA.txt";
    public static String algebra_edison2006_in = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\edison_middle_school_838_export.txt";
    public static String algebra_edison2006_out = "C:\\RawData\\Algebra_I_2006_2007_6_schools\\edison_middle_school_838_export-modA.txt";
    public static String RAND2007_in = "H:\\RawData-annex\\RAND_Study_Baltimore_2007_2008\\All_Data_853_export.txt";
    public static String RAND2007_out = "H:\\RawData-annex\\RAND_Study_Baltimore_2007_2008\\All_Data_853_export-modA.txt";
    public static String geo_wilk2005_in = "H:\\RawData-annex\\Geometry_Wilkinsburg_2005_2006\\All_Data_552_export.txt";
    public static String geo_wilk2005_out = "H:\\RawData-annex\\Geometry_Wilkinsburg_2005_2006\\All_Data_552_export-modA.txt";
    public static String geo_cwctc2005_in = "H:\\RawData-annex\\Geometry_CWCTC_2005_2006\\All_Data_548_export.txt";
    public static String geo_cwctc2005_out = "H:\\RawData-annex\\Geometry_CWCTC_2005_2006\\All_Data_548_export-modA.txt";
    public static String geo_wilk2006_in = "H:\\RawData-annex\\Geometry_2006_2007\\wilkinsburgh_896_export.txt";
    public static String geo_wilk2006_out = "H:\\RawData-annex\\Geometry_2006_2007\\wilkinsburgh_896-modA.txt";
    public static String geo_cwctc2006_in = "H:\\RawData-annex\\Geometry_2006_2007\\cwctc_895_export.txt";
    public static String geo_cwctc2006_out = "H:\\RawData-annex\\Geometry_2006_2007\\cwctc_895-modA.txt";
    public static String geo_hampton2006_in = "H:\\RawData-annex\\Geometry_2006_2007\\hampton_897_export.txt";
    public static String geo_hampton2006_out = "H:\\RawData-annex\\Geometry_2006_2007\\hampton_897-modA.txt";

    public static String geometry_hampton_in = "C:\\RawData\\HamptonGeoFall2005\\export.txt";
    public static String geometry_hampton_out = "C:\\RawData\\HamptonGeoFall2005\\export-modA.txt";

    public static String ron_in_1 = "C:\\RawData\\RonExampleTutors\\ExampleCWCTCWinter2007.txt";
    public static String ron_in_2 = "C:\\RawData\\RonExampleTutors\\ExampleFreiburgSpring2007.txt";
    public static String ron_in_3 = "C:\\RawData\\RonExampleTutors\\ExampleSteelValleySpring2007.txt";
    public static String ron_in_4 = "C:\\RawData\\RonExampleTutors\\ExampleCWCTCSpring2007.txt";
    public static String ron_out = "C:\\RawData\\RonExampleTutors\\exampletutor-modA.txt";

    public static String ron_circles_in = "C:\\RawData\\RonExampleTutors\\Circles\\All-Circles.txt";
    public static String ron_circles_out = "C:\\RawData\\RonExampleTutors\\Circles\\All-Circles-modA.txt";

    public static String test_in = "C:\\RawData\\HamptonAlgI0506\\test.txt";
    public static String test_out = "C:\\RawData\\HamptonAlgI0506\\test-modC.txt";

    public String in_file_ = "";
    public String out_file_ = "";

    public FileReader create_tokenizer(String infile){		      
	
	try{
	    return new FileReader(infile);
	}	
	catch (FileNotFoundException fnfe){
	    fnfe.printStackTrace();
	}
	return null;
    }	
    public FileWriter out_tokenizer(String outfile){
	try{
	    return new FileWriter(outfile);
	}
	catch (Exception fnfe){
	    fnfe.printStackTrace();
	}
	return null;
    }    

    public void tab(FileReader in_, FileWriter out_){
	try{
	out_.write(9);
	int inputchar = -1;
	
	inputchar = in_.read();
	while (inputchar == 9){
	    out_.write("BLANK");
	    out_.write(9);    
	    inputchar = in_.read(); 
	}
	if ((inputchar != -1)&&(inputchar!=10))
	    out_.write(inputchar);
	if (inputchar == 10){
	    out_.write("\tEOL");
	    out_.write(10);
	}
	}catch (Exception e){e.printStackTrace();}
    }

    public void preprocess_ron(){
	FileWriter out_ = out_tokenizer(out_file_);
	
	FileReader in_ = null; int inputchar = 0;

	in_ = create_tokenizer(ron_in_1);

        inputchar = 0;

	try{
	while (inputchar != -1){
		inputchar = in_.read();
		if (inputchar != -1){
		    //if (inputchar == 32)
		    //	out_.write(90);
		    //else
		    if (inputchar == 95)
			out_.write(90);
		    else
		    if (inputchar == 10){
			out_.write("\tEOL");
			out_.write(10);
		    }
		    else
		    if (inputchar == 9)
			tab(in_,out_);
		    else{
			out_.write(inputchar);
		    }
		}else
		    out_.write("\tEOL");
		out_.flush();
		
	    }
	    }
	    catch (Exception e){
		e.printStackTrace();
	    }


	in_ = create_tokenizer(ron_in_2);

        inputchar = 0;

	try{
	while (inputchar != -1){
		inputchar = in_.read();
		if (inputchar != -1){
		    //if (inputchar == 32)
		    //	out_.write(90);
		    //else
		    if (inputchar == 95)
			out_.write(90);
		    else
		    if (inputchar == 10){
			out_.write("\tEOL");
			out_.write(10);
		    }
		    else
		    if (inputchar == 9)
			tab(in_,out_);
		    else{
			out_.write(inputchar);
		    }
		}else
		    out_.write("\tEOL");
		out_.flush();
		
	    }
	    }
	    catch (Exception e){
		e.printStackTrace();
	    }


	in_ = create_tokenizer(ron_in_3);

        inputchar = 0;

	try{
	while (inputchar != -1){
		inputchar = in_.read();
		if (inputchar != -1){
		    //if (inputchar == 32)
		    //	out_.write(90);
		    //else
		    if (inputchar == 95)
			out_.write(90);
		    else
		    if (inputchar == 10){
			out_.write("\tEOL");
			out_.write(10);
		    }
		    else
		    if (inputchar == 9)
			tab(in_,out_);
		    else{
			out_.write(inputchar);
		    }
		}else
		    out_.write("\tEOL");
		out_.flush();
		
	    }
	    }
	    catch (Exception e){
		e.printStackTrace();
	    }


	in_ = create_tokenizer(ron_in_4);

        inputchar = 0;

	try{
	while (inputchar != -1){
		inputchar = in_.read();
		if (inputchar != -1){
		    //if (inputchar == 32)
		    //	out_.write(90);
		    //else
		    if (inputchar == 95)
			out_.write(90);
		    else
		    if (inputchar == 10){
			out_.write("\tEOL");
			out_.write(10);
		    }
		    else
		    if (inputchar == 9)
			tab(in_,out_);
		    else{
			out_.write(inputchar);
		    }
		}else
		    out_.write("\tEOL");
		out_.flush();
		
	    }
	    }
	    catch (Exception e){
		e.printStackTrace();
	    }
    }

    public void preprocess(){
	if (in_file_.equals("ronex"))
	    preprocess_ron();
	else{
	    //	System.out.println(in_file_);
	FileReader in_ = create_tokenizer(in_file_);
	FileWriter out_ = out_tokenizer(out_file_);

	int inputchar = 0;

	try{
	while (inputchar != -1){
		inputchar = in_.read();
		if (inputchar != -1){
		    //if (inputchar == 32)
		    //	out_.write(90);
		    //else
		    if (inputchar == 95)
			out_.write(90);
		    else
		    if (inputchar == 10){
			out_.write("\tEOL");
			out_.write(10);
		    }
		    else
		    if (inputchar == 9)
			tab(in_,out_);
		    else{
			out_.write(inputchar);
		    }
		}else
		    out_.write("\tEOL");
		out_.flush();
		
	    }
	    }
	    catch (Exception e){
		e.printStackTrace();
	    }
	
	}}

    public static void main (String args[]){	
	DataShopSTPreprocessorB d_ = new DataShopSTPreprocessorB();

	if (args[0].equals("test")){
	    d_.in_file_ = test_in;
	    d_.out_file_ = test_out;
        }
	if (args[0].equals("ah")){
	    d_.in_file_ = algebra_hampton_in;
	    d_.out_file_ = algebra_hampton_out;
        }
	if (args[0].equals("ac2005")){
	    d_.in_file_ = algebra_cwctc2005_in;
	    d_.out_file_ = algebra_cwctc2005_out;
        }

	if (args[0].equals("ac2006")){
	    d_.in_file_ = algebra_cwctc2006_in;
	    d_.out_file_ = algebra_cwctc2006_out;
        }
	if (args[0].equals("aw2006")){
	    d_.in_file_ = algebra_wilk2006_in;
	    d_.out_file_ = algebra_wilk2006_out;
        }
	if (args[0].equals("ae2006")){
	    d_.in_file_ = algebra_edison2006_in;
	    d_.out_file_ = algebra_edison2006_out;
        }
	if (args[0].equals("ag2006")){
	    d_.in_file_ = algebra_gv2006_in;
	    d_.out_file_ = algebra_gv2006_out;
        }
	if (args[0].equals("ah2006")){
	    d_.in_file_ = algebra_hampton2006_in;
	    d_.out_file_ = algebra_hampton2006_out;
        }
	if (args[0].equals("am2006")){
	    d_.in_file_ = algebra_madison2006_in;
	    d_.out_file_ = algebra_madison2006_out;
        }

	if (args[0].equals("aw2005")){
	    d_.in_file_ = algebra_wilk2005_in;
	    d_.out_file_ = algebra_wilk2005_out;
        }
	if (args[0].equals("geo")){
	    d_.in_file_ = geometry_hampton_in;
	    d_.out_file_ = geometry_hampton_out;
        }
	if (args[0].equals("RAND")){
	    d_.in_file_ = RAND2007_in;
	    d_.out_file_ = RAND2007_out;
        }
	if (args[0].equals("gc2005")){
	    d_.in_file_ = geo_cwctc2005_in;
	    d_.out_file_ = geo_cwctc2005_out; 
        }
	if (args[0].equals("gh2006")){
	    d_.in_file_ = geo_hampton2006_in;
	    d_.out_file_ = geo_hampton2006_out; 
        }
	if (args[0].equals("gc2006")){
	    d_.in_file_ = geo_cwctc2006_in;
	    d_.out_file_ = geo_cwctc2006_out; 
        }
	if (args[0].equals("gw2006")){
	    d_.in_file_ = geo_wilk2006_in;
	    d_.out_file_ = geo_wilk2006_out; 
        }
	if (args[0].equals("gw2005")){
	    d_.in_file_ = geo_wilk2005_in;
	    d_.out_file_ = geo_wilk2005_out; 
        }
	if (args[0].equals("ronex")){
	    d_.in_file_ = "ronex";
	    d_.out_file_ = ron_out;
        }
	if (args[0].equals("circles")){
	    d_.in_file_ = ron_circles_in;
	    d_.out_file_ = ron_circles_out;
        }

	d_.preprocess();
    }
}